"""
Django settings for card1 project.

Generated by 'django-admin startproject' using Django 4.1.1.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

from pathlib import Path
import os


# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-djn(pi^tpuu@@-x0msbih8uaqa=vg9=@ox@6t!6_uwu$2vdqea'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['epg.eu.pythonanywhere.com','127.0.0.1','localhost']

SESSION_EXPIRE_AT_BROWSER_CLOSE = False
SESSION_COOKIE_AGE = 30 * 60 #



# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'cardprn',
    'rest_framework',
    'erscipcard',
    'social_django',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'social_django.middleware.SocialAuthExceptionMiddleware',
]

ROOT_URLCONF = 'card1.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'cardprn/templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django.template.context_processors.i18n',
                'social_django.context_processors.backends',
            ],
        },
    },
]

WSGI_APPLICATION = 'card1.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/



from django.utils.translation import gettext_lazy as _

LANGUAGES = (
    ('fa', _('Persian')),
	('en', _('English')),
)

LOCALE_PATHS = [
    os.path.join(BASE_DIR , 'locale/'),
]

LANGUAGE_CODE = 'fa'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True

#manage.py makemessages -l fa
#Edit djangi.po file in locale directory
#manage.py compilemessages

#CSRF_TRUSTED_ORIGINS = ["https://localhost"]
CSRF_USE_SESSIONS = True
CSRF_COOKIE_HTTPONLY = True

STATIC_URL = '/static/'
#STATIC_ROOT = os.path.join(BASE_DIR, 'cardprn/static')
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, 'cardprn/static'),
    os.path.join(BASE_DIR, 'cardprn/media'),
]

MEDIA_URL = '/media/'
MEDIA_ROOT = (os.path.join(BASE_DIR, 'cardprn/media'))
# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/


#///////////////////////////////////////////////////////////////////////////
#pip install social-auth-app-django

AUTHENTICATION_BACKENDS = [
    'social_core.backends.github.GithubOAuth2',
    'social_core.backends.github.GithubOAuth2',
    'django.contrib.auth.backends.ModelBackend',
]

LOGIN_URL = 'account'
LOGIN_REDIRECT_URL = 'home'
LOGOUT_URL = 'logout'
LOGOUT_REDIRECT_URL = 'account'

SOCIAL_AUTH_GITHUB_KEY = ' '
SOCIAL_AUTH_GITHUB_SECRET = ' '

SOCIAL_AUTH_GOOGLE_OAUTH2_KEY = ' '
SOCIAL_AUTH_GOOGLE_OAUTH2_SECRET = ' '


#add this to app urls.py
#from django.contrib.auth import views as auth_views
#path('logout/', auth_views.LogoutView.as_view(), name='logout'),
#path('social-auth/', include('social_django.urls')), 

#///////////////////////////////////////////////////////////////////////////

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

